{% set labelSlot = app.request.query.get('slot') == 'last6Months' ? '6 derniers mois' : 'Année théocratique en cours'  %}
{% set typeRequest = app.request.get('type') ? app.request.get('type') : 'all' %}
{% set labelType = 'Tous les proclamateurs' %}
{% if typeRequest == 'regular' %}
    {% set labelType = 'Uniquement les pionniers permanent' %}
{% endif %}
{% if typeRequest == 'publisher' %}
    {% set labelType = 'Tous sauf pionniers permanent' %}
{% endif %}
{% set isAllowed = is_granted('ROLE_SERVICE_COMMITTEE') or (group.overseer or group.assistant) is same as app.user.publisher or app.user.publisher.isElder %}
{% set isDisabled = isAllowed ? 'true' : 'false' %}
{% extends 'base.html.twig' %}
{% block header_title %}Groupe {{ group.name }}{% endblock %}
{% block body %}
    <div class="col-12">
        <div class="row mb-4">
            <div class="col-lg-8">
                <div class="card card-bordered">
                    <div class="card-inner">
                        <h5 class="card-title">
                            Historique des territoires ({{ histories|length }})
                        </h5>
                        <span class="text-muted"><em class="ni ni-info-fill"></em> Uniquement les territoires sortis </span>

                        {% if histories is not empty %}
                            <div>
                                <div class="nk-tb-list nk-tb-orders">
                                    <div class="nk-tb-item nk-tb-head">
                                        <div class="nk-tb-col tb-col"><span>#</span></div>
                                        <div class="nk-tb-col"><span>Procl.</span></div>
                                        <div class="nk-tb-col"><span>Sortie</span></div>
                                        <div class="nk-tb-col tb-col"><span></span></div>
                                    </div>

                                    {% for history in histories %}
                                        <div class="nk-tb-item">
                                            <div class="nk-tb-col">
                                                <div class="user-card">
                                                    <div class="user-name">
                                                        <span class="tb-lead"><a href="{{ path('app_territory_show', {'territory': history.territory.id}) }}">{{ history.territory.area.title }} {{ history.territory.title }}</a></span>
                                                    </div>
                                                </div>
                                            </div>
                                            <div class="nk-tb-col tb-col">
                                                <span><a href="{{ path('app_publisher_show', {'id': history.publisher.id}) }}">{{ history.publisher.fullName }}</a></span>
                                            </div>
                                            <div class="nk-tb-col tb-col">
                                                {% if history.outDate|territoryDateValidation('4 months')|date('U') < "now"|date('U') and history.inDate is null %}
                                                    <span class="badge badge-dot bg-danger">{{ history.outDate|date('d/m/y') }}</span>
                                                {% else %}
                                                    <span class="badge badge-dot bg-secondary">{{ history.outDate|date('d/m/y') }}</span>
                                                {% endif %}
                                            </div>

                                            <div class="nk-tb-col nk-tb-col-action">
                                                <div class="dropdown">
                                                    <a class="text-soft dropdown-toggle btn btn-icon btn-trigger" data-bs-toggle="dropdown"><em class="icon ni ni-more-h"></em></a>
                                                    <div class="dropdown-menu dropdown-menu-end dropdown-menu-xs">
                                                        <ul class="link-list-plain">
                                                            <li><a href="{{ path('app_territory_show', {'territory': history.territory.id}) }}">Voir territoire</a></li>
                                                            <li><a href="{{ path('app_territory_history_edit', {'history': history.id}) }}">Modifier</a></li>
                                                            {% if is_granted('ROLE_ADMIN') is same as true %}
                                                                <li><a href="{{ path('app_territory_history_remove', {'history': history.id}) }}">Supprimer</a></li>
                                                            {% endif %}
                                                        </ul>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                    {% endfor %}
                                </div>
                            </div>
                        {% else %}
                            <div class="alert alert-pro alert-info">Aucun territoire dans l'historique</div>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>

        <div class="row">
            <div class="col-12 {{ isAllowed ? 'col-lg-12' : 'col-lg-6' }}">
                <div class="card card-bordered card-full">
                    <div class="card-inner">
                        <div class="card-title-group">
                            <div class="card-title">
                                <h6 class="title">
                                    <span class="me-2">{{ labelType}} ({{ publishers|length }})</span>
                                </h6>
                            </div>
                        </div>
                    </div>
                    <div class="card-inner p-0 border-top">
                        <div class="nk-tb-list nk-tb-orders">
                            <div class="nk-tb-item nk-tb-head">
                                <div class="nk-tb-col tb-col"><span>Nom</span></div>
                                <div class="nk-tb-col"><span>Attribution</span></div>
                                {% if isAllowed %}
                                    <div class="nk-tb-col tb-col-md"><span>Heures</span></div>
                                    <div class="nk-tb-col tb-col-md"><span>Publications</span></div>
                                    <div class="nk-tb-col tb-col-md"><span>Visites</span></div>
                                    <div class="nk-tb-col tb-col-md"><span>Cours bibliques</span></div>
                                    <div class="nk-tb-col tb-col-md"><span>Vidéos</span></div>
                                    <div class="nk-tb-col tb-col-md"><span>Autre (LDC/Bethel)</span></div>
                                    <div class="nk-tb-col"><span>&nbsp;</span></div>
                                {% endif %}
                            </div>
                            {% for publisher in publishers %}
                                <div class="nk-tb-item">
                                    <div class="nk-tb-col">
                                        <div class="user-card">
                                            <div class="user-name">
                                            <span class="tb-lead">
                                                {% if isAllowed %}
                                                    <a target="_blank" href="{{ path('app_publisher_show', {'id': publisher.id}) }}">{{ publisher.fullName }}</a>
                                                {% else %}
                                                    {{ publisher.fullName }}
                                                {% endif %}
                                            </span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="nk-tb-col">
                                        <div>
                                            <div>
                                                {% if publisher == publisher.serviceGroup.overseer %}
                                                    <span class="badge bg-danger">Responsable</span>
                                                {% endif %}
                                                {% if publisher == publisher.serviceGroup.assistant %}
                                                    <span class="badge bg-warning">Adjoint</span>
                                                {% endif %}
                                                {% if publisher.isServant %}
                                                    <span class="badge bg-primary">Assistant</span>
                                                {% endif %}
                                                {% if publisher.isElder %}
                                                    <span class="badge bg-success">Ancien</span>
                                                {% endif %}
                                                {% if publisher.isRegularPioneer %}
                                                    <span class="badge bg-secondary">Pionnier permanent</span>
                                                {% endif %}
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            </div>
            {% if isAllowed %}
                <div class="col-lg-6 mt-4">
                    <div id="accordion" class="accordion">
                        <div class="accordion-item">
                            <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-1">
                                <h6 class="title"><em class="icon ni ni-user-add me-1"></em> Ajouter un proclamateur</h6>
                                <span class="accordion-icon"></span>
                            </a>
                            <div class="accordion-body collapse" id="accordion-item-1" data-bs-parent="#accordion">
                                <div class="accordion-inner">
                                    <form action="{{ path('app_fieldservice_servicegroup_show', {'id': group.id}) }}" method="post">
                                        <div class="row">
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    {{ form_label(formPublisher.firstName) }}
                                                    {{ form_widget(formPublisher.firstName) }}
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    {{ form_label(formPublisher.lastName) }}
                                                    {{ form_widget(formPublisher.lastName) }}
                                                </div>
                                            </div>
                                            <div class="col-md-6">
                                                <div class="form-group">
                                                    {{ form_label(formPublisher.gender) }}
                                                    {{ form_widget(formPublisher.gender) }}
                                                </div>
                                            </div>
                                            <div class="col-md-6 mt-2">
                                                <div class="form-group">
                                                    {{ form_label(formPublisher.isElder) }}
                                                    {{ form_widget(formPublisher.isElder) }}
                                                    {{ form_label(formPublisher.isServant) }}
                                                    {{ form_widget(formPublisher.isServant) }}
                                                    {{ form_label(formPublisher.isRegularPioneer) }}
                                                    {{ form_widget(formPublisher.isRegularPioneer) }}
                                                </div>
                                            </div>
                                            <div class="col-md-12 mt-4">
                                                {{ form_widget(formPublisher._token) }}
                                                <button class="btn btn-success"><em class="icon ni ni-save-fill me-1"></em> Enregistrer</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="accordion-item">
                            <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-2">
                                <h6 class="title"><em class="icon ni ni-user-add me-2"></em> Configuration du groupe</h6>
                                <span class="accordion-icon"></span>
                            </a>
                            <div class="accordion-body collapse show" id="accordion-item-2" data-bs-parent="#accordion">
                                <div class="accordion-inner">
                                    <form action="{{ path('app_fieldservice_servicegroup_show', {'id': group.id}) }}" method="post">
                                        <div class="row">
                                            <div class="col-md-12">
                                                <div class="form-group">
                                                    {{ form_label(formServiceGroup.name) }}
                                                    {{ form_widget(formServiceGroup.name) }}
                                                </div>
                                            </div>
                                            <div class="col-md-6 mt-2">
                                                <div class="form-group">
                                                    {{ form_label(formServiceGroup.overseer) }}
                                                    {{ form_widget(formServiceGroup.overseer) }}
                                                </div>
                                            </div>
                                            <div class="col-md-6 mt-2">
                                                <div class="form-group">
                                                    {{ form_label(formServiceGroup.assistant) }}
                                                    {{ form_widget(formServiceGroup.assistant) }}
                                                </div>
                                            </div>
                                            <div class="col-md-12 mt-4">
                                                {{ form_widget(formServiceGroup._token) }}
                                                <button class="btn btn-success"><em class="icon ni ni-save-fill me-1"></em> Enregistrer</button>
                                            </div>
                                        </div>
                                    </form>
                                </div>
                            </div>
                        </div>
                        <div class="accordion-item">
                            <a href="#" class="accordion-head" data-bs-toggle="collapse" data-bs-target="#accordion-item-3">
                                <h6 class="title"><em class="icon ni ni-trash-alt me-2"></em> Suppression du groupe</h6>
                                <span class="accordion-icon"></span>
                            </a>
                            <div class="accordion-body collapse" id="accordion-item-3" data-bs-parent="#accordion">
                                <div class="accordion-inner">
                                    <a href="#" class="btn btn-danger" id="removeGroupBtn">Supprimer défintivement</a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            {% endif %}
        </div>
    </div>
{% endblock %}

{% block javascripts %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.29.4/moment-with-locales.min.js"></script>
    <script>
        const $removeGroupBtn = document.getElementById('removeGroupBtn');
        $removeGroupBtn.addEventListener('click', function (e) {
            e.preventDefault();
            if (confirm('Souhaites-tu supprimer définitivement ce groupe de prédication ?')) {
                fetch("{{ path('app_fieldservice_servicegroup_delete', {'id': group.id}) }}", {
                    method: 'DELETE'
                }).then(function(response) {
                    return window.location = "{{ path('app_fieldservice_servicegroup_list') }}"
                })
            }
        })


        moment.locale('fr');
        const ctx = document.getElementById('filledLineChart');
        const $compilations = $('#filledLineChart').data('compilations')

        const dataTimes = [];
        const dataDates = [];
        const dataColors = [];
        $compilations.forEach((comp) => {
            let date = new Date(comp.date);
            dataTimes.push(comp.timesAvg);
            dataDates.push(moment.utc(date).format('MMMM Y'))
            dataColors.push('rgba(215,220,255,0.5)');
        })

        const data = {
            labels: dataDates,
            datasets: [{
                label: 'Moyenne d\'heures par mois',
                data: dataTimes,
                backgroundColor: 'rgba(215,220,255,0.5)',
                borderColor: 'rgba(28,112,227,0.89)',
                borderWidth: 1
            }]
        };

        new Chart(ctx, {
            type: 'line',
            data: data,
            options: {
                scales: {
                    yAxes: [{
                        ticks: {
                            beginAtZero: true
                        }
                    }]
                }
            }
        });
    </script>
{% endblock %}
